const self = {
	
   requiredParameters: (type: string = "GET", params: (string | TestableParam)[]) => {

        return function (req, res, next) {

            let bodyType = ((type == "GET") ? req.params : (type == "GETq") ? req.query : req.body);
                
            let missing = new Array();
            let invalid = new Array();

            for (var i = 0; i < params.length; i++) {
                
                if(params[i].hasOwnProperty("name")){

                    let parameter = <TestableParam>params[i];

                    if(!bodyType[parameter.name]){
                        missing.push(parameter.name);
                        continue;
                    }

                    if(!parameter.re.test(bodyType[parameter.name]))
                        invalid.push({
                            name: parameter.name,
                            test: parameter.re.toString()
                        })

                }else{
                    
                    if (!bodyType[<string>params[i]])
                        missing.push(params[i])

                }
            }

            let err = new HTTPError('bad_request', 400);

            if(missing.length > 0)
                err.addParam('missing_parameters', missing);
            
            if(invalid.length > 0)
                err.addParam('invalid_parameters', invalid);

            if(missing.length || invalid.length)
                return err.toResponse(res);

            next();

        }

    }

};

export default self;
