"use strict";
var __classPrivateFieldSet = (this && this.__classPrivateFieldSet) || function (receiver, privateMap, value) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to set private field on non-instance");
    }
    privateMap.set(receiver, value);
    return value;
};
var __classPrivateFieldGet = (this && this.__classPrivateFieldGet) || function (receiver, privateMap) {
    if (!privateMap.has(receiver)) {
        throw new TypeError("attempted to get private field on non-instance");
    }
    return privateMap.get(receiver);
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
var _options, _mail_path, _transporter;
Object.defineProperty(exports, "__esModule", { value: true });
const nodemailer_1 = require("nodemailer");
const fs_extra_1 = require("fs-extra");
const utils_1 = __importDefault(require("./utils"));
const path_1 = __importDefault(require("path"));
class Email {
    constructor(options) {
        _options.set(this, void 0);
        _mail_path.set(this, path_1.default.resolve(`${__dirname}/../../mails`));
        _transporter.set(this, void 0);
        __classPrivateFieldSet(this, _options, options);
        __classPrivateFieldSet(this, _transporter, nodemailer_1.createTransport({
            host: 'ssl0.ovh.net',
            port: 465,
            secure: true,
            auth: {
                user: process.env.EMAIL_ACCOUNT,
                pass: process.env.EMAIL_PASSWORD
            }
        }));
    }
    async send() {
        let html;
        if (__classPrivateFieldGet(this, _options).filename)
            html = Buffer.from(await fs_extra_1.readFile(`${__classPrivateFieldGet(this, _mail_path)}/${__classPrivateFieldGet(this, _options).filename}`)).toString('utf-8');
        else
            html = __classPrivateFieldGet(this, _options).html;
        if (Object.keys(__classPrivateFieldGet(this, _options).variables).length > 0)
            html = utils_1.default.tokenize(html, __classPrivateFieldGet(this, _options).variables);
        return await __classPrivateFieldGet(this, _transporter).sendMail({
            from: '"TheList website" <postmaster@emilianomaccaferri.com>',
            to: process.env.THELIST_EMAIL,
            subject: __classPrivateFieldGet(this, _options).subject,
            html
        });
    }
}
exports.default = Email;
_options = new WeakMap(), _mail_path = new WeakMap(), _transporter = new WeakMap();
