"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const HTTPError_1 = __importDefault(require("./HTTPError"));
const axios_1 = __importDefault(require("axios"));
exports.default = {
    requiredParameters: (type = "GET", params) => {
        return function (req, res, next) {
            let bodyType = ((type == "GET") ? req.params : (type == "GETq") ? req.query : req.body);
            let missing = new Array();
            for (var i = 0; i < params.length; i++) {
                if (!bodyType[params[i]])
                    missing.push(params[i]);
            }
            if (missing.length > 0)
                return HTTPError_1.default.missingParameters(...missing).toResponse(res);
            next();
        };
    },
    tokenize: function (str, vars) {
        Object.keys(vars).forEach((k) => {
            let value = vars[k];
            str = str.replace(new RegExp(`%${k}%`, "g"), value);
        });
        console.log("tokenized %s", str);
        return str;
    },
    verifyCaptcha: async (key, captcha) => {
        return new Promise((resolve, reject) => {
            axios_1.default({
                method: 'post',
                url: 'https://www.google.com/recaptcha/api/siteverify',
                params: {
                    secret: key,
                    response: captcha
                }
            })
                .then(success => {
                resolve(true);
            })
                .catch(err => {
                resolve(false);
            });
        });
    }
};
