import HTTPError from './HTTPError';
import axios, { AxiosResponse, AxiosError } from 'axios';

export default {
    requiredParameters: (type: string = "GET", params: any[]) => {

        return function (req, res, next) {

            let bodyType = ((type == "GET") ? req.params : (type == "GETq") ? req.query : req.body);
                
            let missing = new Array();

            for (var i = 0; i < params.length; i++) {
                if (!bodyType[params[i]])
                    missing.push(params[i])
            }

            if (missing.length > 0)
                return HTTPError.missingParameters(...missing).toResponse(res);

            next();

        }

    },
    tokenize: function(str: string, vars: {[key: string]: any}): string{
  
        Object.keys(vars).forEach((k) => {
 
            let value = vars[k];
            str = str.replace(new RegExp(`%${k}%`, "g"), value);
  
        });

        console.log("tokenized %s", str);

        return str;
    },
    verifyCaptcha: async(key: string, captcha: string): Promise<boolean> => {
        
        return new Promise(
            (resolve, reject) => {

                axios({
                    method: 'post',
                    url: 'https://www.google.com/recaptcha/api/siteverify',
                    params: {
                        secret: key,
                        response: captcha
                    }
                })
                .then(success => {
                    
                    resolve(true);

                })

                .catch(err => {
                    
                    resolve(false);

                })

            }
        )
    
    }
}