import 'balloon-css';
import Vue from 'vue';
import axios from 'axios';

const app = new Vue({
    el: '#container',
    data: {
        email: '',
        name: '',
        surname: '',
        date: '',
        time: '',
        text: '',
        alert: '',
    },
    methods: {
        send: function(){

            axios.post('/affitta-un-posto', {
                email: this.email,
                name: this.name,
                surname: this.surname,
                date: this.date,
                time: this.time,
                text: this.text,
                captcha: window.captcha

            })

            .then(success => {

                this.alert = "Richiesta inviata con successo! Ti risponderemo nel minor tempo possibile."

            })

            .catch(err => {

                let data = err.response.data;
                console.log(data);

                switch(data.status){

                    case 400:

                        this.alert = "Controlla il form: tutti i campi sono obbligatori!";

                    break;

                    default:

                        this.alert = "C'è stato un errore durante l'esecuzione della richiesta... Riprova.";

                    break;

                }

            })

        }
    },
    delimiters: ['[[', ']]']
})

function callback(cb){
    app.captcha = cb;
}