const path = require('path');

module.exports = {
    mode: 'production',
    externals: {
        grecaptcha: 'grecaptcha'
    },
    entry: {
        home: "./app/ts/home.ts",
        rent: "./app/ts/rent.ts",
        menu: "./app/ts/menu.ts"       
    },
    output: {
        path: path.resolve('./app/assets/js'),
        filename: "[name].bundle.js"
    },
    resolve: {
        alias: {
            'vue$': 'vue/dist/vue.esm.js'
        },
        extensions: [".ts", ".tsx", ".js", "*", ".js", ".vue", ".json"]
    },
    module: {
        rules: [
            // tutti i file .ts devono essere compilati da ts-loader
            { test: /\.tsx$/, loader: "ts-loader" },
            { test: /\.css$/, use: [
                    'style-loader', 
                    'css-loader',
                    'sass-loader'
                ]
            },
            {
                test: /\.vue$/,
                loader: 'vue-loader'
            },
            {
                test: /\.(svg|eot|woff|woff2|ttf)$/,
                use: ['file-loader']
            }
        ]
    }

}
